質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

新規登録して質問してみよう
ただいま回答率
85.53%
Java

Javaは、1995年にサン・マイクロシステムズが開発したプログラミング言語です。表記法はC言語に似ていますが、既存のプログラミング言語の短所を踏まえていちから設計されており、最初からオブジェクト指向性を備えてデザインされています。セキュリティ面が強力であることや、ネットワーク環境での利用に向いていることが特徴です。Javaで作られたソフトウェアは基本的にいかなるプラットフォームでも作動します。

Q&A

解決済

2回答

25957閲覧

Java8のラムダ式(stream)を使用した場合の例外処理について

kidss

総合スコア12

Java

Javaは、1995年にサン・マイクロシステムズが開発したプログラミング言語です。表記法はC言語に似ていますが、既存のプログラミング言語の短所を踏まえていちから設計されており、最初からオブジェクト指向性を備えてデザインされています。セキュリティ面が強力であることや、ネットワーク環境での利用に向いていることが特徴です。Javaで作られたソフトウェアは基本的にいかなるプラットフォームでも作動します。

1グッド

1クリップ

投稿2015/04/11 07:25

次のコードのようにラムダ式を使った記述の中で、例外をthrowするメソッドがあった場合、中でtry-catchを記述せずに、ラムダ式の外で例外をcatchしたいのですが、可能でしょうか?

ラムダ式の中から外に例外をthrowしようとしてもtry-catchを書けとエラーになってしまいます。恐らく基本的な事が分かってないのかもしれませんが、ご教授いただけると幸いです。

lang

1try { 2... 3 names.stream().forEach(name -> { 4 try { 5 method(name); // 例外をthrowするメソッド 6 } catch (Exception e) { 7 // ここで例外処理はしたくない 8 } 9 }); 10 11} catch (Exception e) { 12 // ここでcatchしたい 13}
ikuwow👍を押しています

気になる質問をクリップする

クリップした質問は、後からいつでもMYページで確認できます。

またクリップした質問に回答があった際、通知やメールを受け取ることができます。

バッドをするには、ログインかつ

こちらの条件を満たす必要があります。

guest

回答2

0

ベストアンサー

Stream API+ラムダ式による処理では、検査例外(checked exception)を上手く扱えません。(検査例外という仕組みの失敗とも言われ、Java言語仕様上の大きな欠点になってしまいました。)

メソッドmethod()が検査例外をスローする場合、非検査例外(unchecked exception)で一旦ラップする必要があります。RuntimeExceptionは非検査例外クラスのため、thorws節のないメソッド(ラムダ式)からでも自由にスローできます。

lang

1try { 2 3 names.stream().forEach(name -> { 4 try { 5 method(name); // 例外をthrowするメソッド 6 } catch (Exception e) { 7 // 非検査例外RuntimeExceptionでラップ 8 throw new RuntimeException(e); 9 } 10 }); 11 12} catch (RuntimeException re) { 13 Throwable e = re.getCause(); 14 // 元の例外を取り出して処理 15}

余談ですが、検査例外IOExceptionに対応する非検査例外として、Java8からUncheckedIOException標準ライブラリに追加されました。IOExceptionをラップする場合は、RuntimeExceptionよりもこちらの方が相応しいと思います。

投稿2015/04/11 11:53

yohhoy

総合スコア6187

バッドをするには、ログインかつ

こちらの条件を満たす必要があります。

kidss

2015/04/11 12:24

非常に分かりやすかったです。調べるとRuntimeExceptionでラップするというのは出てきてたのですが意味がわからず、検査例外・非検査例外の基本が分かってなかったようです。ありがとうございました。
guest

0

チェック例外でなければできます。

下記のコードを動かすと、外側でキャッチできるのが分かります。

lang

1import java.util.Arrays; 2import java.util.List; 3 4public final class App { 5 6 public static void main(String[] args) { 7 List<String> names = Arrays.asList("aaa", "bbb"); 8 try { 9 names.stream().forEach(name -> { 10 method(name); 11 }); 12 } catch (Exception e) { 13 e.printStackTrace(); // 例外をthrowするメソッド 14 } 15 } 16 17 static void method(String name) { 18 throw new RuntimeException("error: " + name); 19 } 20 21}

参考URL:
もしもラムダの中で例外が発生したら(前編)

投稿2015/04/11 10:18

argius

総合スコア9388

バッドをするには、ログインかつ

こちらの条件を満たす必要があります。

kidss

2015/04/11 12:25

試してみると外側でcatchされるのがよくわかりました。実際に試せると理解が深まります。参考URLも大変勉強になります。ありがとうございました。
guest

あなたの回答

tips

太字

斜体

打ち消し線

見出し

引用テキストの挿入

コードの挿入

リンクの挿入

リストの挿入

番号リストの挿入

表の挿入

水平線の挿入

プレビュー

15分調べてもわからないことは
teratailで質問しよう!

ただいまの回答率
85.53%

質問をまとめることで
思考を整理して素早く解決

テンプレート機能で
簡単に質問をまとめる

質問する

関連した質問